"use strict";
OB_ready(OB_doWhenReady);

function OB_doWhenReady() {
    // localize everything
    var ooohBoi = window.ooohBoi || {};
    // local scope variables
    ooohBoi.prev_scroll_pos = window.scrollY || document.body.scrollTop;
    ooohBoi.cur_scroll_pos;
    ooohBoi.scroll_direction = 'init';
    ooohBoi.prev_scroll_direction = 0;
    ooohBoi.header = document.querySelector('.wrapper > .mainnavcontainer > .mainnav'); // header ID
    ooohBoi.header_pos = {
        top: ooohBoi.header.offsetTop,
        left: ooohBoi.header.offsetLeft,
    };
    ooohBoi.header_height = OB_outerHeight(ooohBoi.header);
    // show-hide header with ease/transition
    ooohBoi.header.style.transition = 'all 0.3s ease';
    // update header height on window resize
    ooohBoi.updateHeaderHeight = function () {
        ooohBoi.header_height = OB_outerHeight(ooohBoi.header);
    }
    // listen "scroll" event and decide what to do
    ooohBoi.checkScroll = function () {
        ooohBoi.cur_scroll_pos = window.scrollY || document.body.scrollTop;

        if (ooohBoi.cur_scroll_pos > ooohBoi.prev_scroll_pos) ooohBoi.scroll_direction = 'down';
        else if (ooohBoi.cur_scroll_pos < ooohBoi.prev_scroll_pos) ooohBoi.scroll_direction = 'up';

        if (ooohBoi.scroll_direction !== ooohBoi.prev_scroll_direction) ooohBoi.toggleHeader(ooohBoi.scroll_direction, ooohBoi.cur_scroll_pos);
        ooohBoi.prev_scroll_pos = ooohBoi.cur_scroll_pos;
    }
    // add or remove class based on the scrolling direction
    ooohBoi.toggleHeader = function (scroll_direction, scroll_current) {
        if (scroll_direction === 'down' && scroll_current > ooohBoi.header_height) {
            OB_addClass(ooohBoi.header, 'im-hidden'); // for styling
            OB_removeClass(ooohBoi.header, 'im-initial');
            ooohBoi.header.style.top = -1 * ooohBoi.header_height + "px";
            ooohBoi.prev_scroll_direction = scroll_direction;


        } else if (scroll_direction === 'up') {
            OB_removeClass(ooohBoi.header, 'im-hidden');
            OB_removeClass(ooohBoi.header, 'im-initial');
            ooohBoi.header.style.top = ooohBoi.header_pos.top + "px";
            ooohBoi.prev_scroll_direction = scroll_direction;
        }
    }
    // listen "scroll" and "resize" window events
    window.addEventListener('scroll', ooohBoi.checkScroll);
    window.addEventListener('resize', ooohBoi.updateHeaderHeight);
}

function OB_outerHeight(el) {
    var height = el.offsetHeight;
    var style = getComputedStyle(el);
    height += parseInt(style.marginTop) + parseInt(style.marginBottom);
    return height;
}

function OB_addClass(el, className) {
    if (el.classList) el.classList.add(className);
    else {
        var current = el.className,
            found = false;
        var all = current.split(' ');
        for (var i = 0; i < all.length, !found; i++) found = all[i] === className;
        if (!found) {
            if (current === '') el.className = className;
            else el.className += ' ' + className;
        }
    }
}

function OB_removeClass(el, className) {
    if (el.classList) el.classList.remove(className);
    else el.className = el.className.replace(new RegExp('(^|\\b)' + className.split(' ').join('|') + '(\\b|$)', 'gi'), ' ');
}

function OB_ready(fn) {
    if (document.readyState != 'loading') fn();
    else if (document.addEventListener) document.addEventListener('DOMContentLoaded', fn);
    else {
        document.attachEvent('onreadystatechange', function () {
            if (document.readyState != 'loading') fn();
        });
    }
}


$(function () {

    //caches a jQuery object containing the header element
    var header = $(".wrapper > .mainnavcontainer > .mainnav");
    header.addClass('im-initial');

    $(window).scroll(function () {
        var scroll = $(window).scrollTop();

        if (scroll >= 120) {
            header.removeClass('im-initial');
        } else if (scroll >= 120) {
            header.removeClass('im-initial-hide');
        }
        else {
            header.addClass('im-initial');
        }
    });
    
    if ($('.testimonials .slider').length) {
        $(".testimonials .slider").owlCarousel({
            items: 1,
            loop: true,
            smartSpeed: 500,
            dots: false,
            nav: true, // Show next and prev buttons
            navText: ["<i class='fal fa-chevron-left'></i><span class='sr-only'>Vorige</span>", "<i class='fal fa-chevron-right'></i><span class='sr-only'>Volgende</span>"],                        
            autoplayHoverPause: false,
            mouseDrag: false            
        });
    }



    var slideUp = {
        delay: 400,
        duration: 1000,
        distance: '30px',
        origin: 'bottom',
        opacity: 0,
        reset: false
    };

    var slideDown = {
        delay: 400,
        duration: 1000,
        distance: '30px',
        origin: 'top',
        opacity: 0,
        reset: false
    };

    var fadeIn = {
        delay: 400,
        duration: 1000,
        distance: '0',
        //origin: 'left',
        opacity: 0,
        reset: false
    };

    var slideInLeft = {
        delay: 500,
        duration: 1500,
        distance: '200%',
        origin: 'left',
        opacity: 0,
        reset: false
    };

    var slideInRight = {
        delay: 400,
        duration: 2500,
        distance: '75%',
        origin: 'right',
        opacity: 0,
        reset: false
    };    

    var fadeInLeft = {
        delay: 400,
        duration: 1500,
        distance: '100px',
        origin: 'left',
        opacity: 0,
        reset: false
    };

    var fadeInRight = {
        delay: 400,
        duration: 1500,
        distance: '100px',
        origin: 'right',
        opacity: 0,
        reset: false
    };

    var fadeInOne = {
        delay: 300,
        duration: 1000,
        distance: '102%',
        origin: 'bottom',
        opacity: 0,
        reset: false
    };

    var fadeInTwo = {
        delay: 500,
        duration: 1000,
        distance: '102%',
        origin: 'bottom',
        opacity: 0,
        reset: false
    };

    var fadeInThree = {
        delay: 700,
        duration: 1000,
        distance: '102%',
        origin: 'bottom',
        opacity: 0,
        reset: false
    };

    ScrollReveal().reveal('#slider1 .slide picture', slideInRight);
    ScrollReveal().reveal('#slider1 .slide .carouselcaption', slideInLeft);
    ScrollReveal().reveal('.home .wrapper .mainnavcontainer .mainnav ', fadeIn);

    ScrollReveal().reveal('.slideUp', slideUp);
    ScrollReveal().reveal('.home .textblock7', slideUp);

    ScrollReveal().reveal('.home .main-content .image', fadeInLeft);
    ScrollReveal().reveal('.home .main-content .text', fadeInRight);
    ScrollReveal().reveal('.home #object-search', fadeIn);

    ScrollReveal().reveal('.home .specials .intro', fadeIn);
    //ScrollReveal().reveal('.home .specials .object .data', fadeInLeft);
    ScrollReveal().reveal('.home .specials .special-carousel', fadeInRight);
    
    //ScrollReveal().reveal('.home .sys-textblock .text', slideUp);
    ScrollReveal().reveal('.home .ctaBlock.textblock1', fadeInOne);
    ScrollReveal().reveal('.home .ctaBlock.textblock2', fadeInTwo);
    ScrollReveal().reveal('.home .ctaBlock.textblock3', fadeInThree);
    ScrollReveal().reveal('.home .textblock5 .text .content', slideUp);
    //ScrollReveal().reveal('.home .testimonials', fadeInLeft);
    ScrollReveal().reveal('.home .employee-carousel', fadeInLeft);
    
    ScrollReveal().reveal('.home .soldandrented-carousel', fadeInLeft);

    ScrollReveal().reveal('.page .sys-textblock .text', fadeInLeft);
    ScrollReveal().reveal('.page .sys-textblock .image', fadeInRight);
  
    ScrollReveal().reveal('.offerlistingpage  .sys-textblock .text', fadeInLeft);
    ScrollReveal().reveal('.offerlistingpage  .sys-textblock .image', fadeInRight);
   
    ScrollReveal().reveal('.faqpage  .sys-textblock .text', fadeInLeft);
    ScrollReveal().reveal('.faqpage  .sys-textblock .image', fadeInRight);
   
    ScrollReveal().reveal('.linkspage  .sys-textblock .text', fadeInLeft);
    ScrollReveal().reveal('.linkspage  .sys-textblock .image', fadeInRight);
    
    ScrollReveal().reveal('.page .main .text.page .text', fadeInLeft);
    ScrollReveal().reveal('.main .main-article .text', fadeInLeft);
    ScrollReveal().reveal('.searchresults.berlin .object_list .object', slideUp);
});